﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Facebook_Authentication
{
    /// <summary>
    /// Interaction logic for FBAuthentication.xaml
    /// </summary>
    public partial class FBAuthentication : Window
    {
        public string AccessToken
        {
            set;
            get;
        }

        public string ExpiresIn
        {
            set;
            get;
        }

        public FBAuthentication(string clientID, string redirectUrl, string scope)
        {
            InitializeComponent();

            string navigationUrl = String.Concat(String.Format(String.Concat("https://graph.facebook.com/oauth/authorize?",
                                                "client_id={0}&redirect_uri={1}&scope={2}"), clientID, redirectUrl, scope),
                                                "&type=user_agent",
                                                "&display=popup");

            browser.Navigate(new Uri(navigationUrl).AbsoluteUri);
        }

        private void browser_Navigated(object sender, System.Windows.Forms.WebBrowserNavigatedEventArgs e)
        {
            this.addressTextBox.Text = e.Url.ToString();

            if (this.addressTextBox.Text.StartsWith("http://www.facebook.com/connect/login_success.html"))
            {
                string queryString = e.Url.Fragment;
                string[] parameters = queryString.Split(new char[] { '&' }, StringSplitOptions.RemoveEmptyEntries);

                foreach (string parameter in parameters)
                {
                    List<string> parameterList = parameter.Split(new char[] { '=' }, StringSplitOptions.RemoveEmptyEntries).ToList();

                    if (parameterList.ElementAt(0).Equals("#access_token"))
                    {
                        AccessToken = parameterList.ElementAt(1);
                    }
                    else if (parameterList.ElementAt(0).Equals("expires_in"))
                    {
                        ExpiresIn = parameterList.ElementAt(1);
                    }
                }

                this.Close();
            }
        }
    }
}
